{g-vars.i &vsh = "shared"}
{show-header-frame-def.i}

screen-title = "Rates Listing".

def var by-room as log init no.
def var room-type like rate.type-of-room format ">>>,>>>,>>>".
def var start-date like rate.start-date.
def var end-date like rate.end-date.
def var output-to as log format "Terminal/File".
def var by-floor as log format "Floor/Room Type".
def var i as int.
def var c-rate like rate.rate label "Current".

form  start-date label "Start Date" at row 1 col 20 colon-aligned help "Leave blank for all before"
      end-date label "End Date" at row 2 col 20 colon-aligned help "Leave blank for all after"
      by-floor label "Group by" at row 3 col 20 colon-aligned help "Group by (F)loor or (R)oom-type"
      by-room label "Set room type?" at row 4 col 20 colon-aligned view-as toggle-box
      room-type view-as combo-box inner-lines 5  label "Room type" at row 5 col 20 colon-aligned
      with frame f1 centered side-labels.

run set-room-types-combo (input room-type:handle in frame f1).

def temp-table t-floor field floor like room.floor.

def temp-table t-room-type field type like room.type-of-room field name as char format "x(20)"  label "Room Type".
do i = 1 to total-floor-no transaction:
   create t-floor.
   t-floor.floor = i.
end.

do i = 1 to extent(room-types) transaction:
   create t-room-type.
   t-room-type.type = i.
   t-room-type.name = room-types[i].
end.

repeat on endkey undo, leave:
   {show-header.i}

   on "value-changed" of by-room do:
      room-type:sensitive in frame f1 = by-room:input-value.
   end.

   update start-date end-date by-floor by-room with frame f1.
   assign room-type.
   
   message "Output (T)erminal or (F)ile" update output-to.
   
   hide frame f1 no-pause.
   
   if output-to
   then do:
      
      if by-floor then do:

         form t-floor.floor
              t-room-type.name
              rate.start-date 
              rate.end-date
              rate.rate
              with frame rt-1 down.
         
         clear frame rt-1 all no-pause.
         
         for each t-floor, 
            each t-room-type 
               where (if by-room then t-room-type.type = room-type else true),
            each rate
               where rate.floor = t-floor.floor and
                     rate.type-of-room = t-room-type.type and
                     (if start-date = ? then true else rate.start-date <= start-date) and
                     (if end-date = ? then true else rate.end-date >= end-date)
               no-lock
            break by t-floor.floor
                  by t-room-type.type:

               if first-of(t-room-type.type) then c-rate = ?.
               
               if c-rate = ? and rate.end-date >= today then c-rate = rate.rate.

               display t-floor.floor when first-of(t-floor.floor)
                       t-room-type.name when first-of(t-room-type.type)
                       rate.start-date 
                       rate.end-date
                       rate.rate
                       with frame rt-1.
               down with frame rt-1.

               if last-of(t-room-type.type) then do:
                  display "Current Rate" @ t-room-type.name 
                          c-rate @ rate.rate 
                          with frame rt-1.
                  down with frame rt-1.
               end.
         end.

      end.
      else do:
         form t-room-type.name
              t-floor.floor
              rate.start-date 
              rate.end-date
              rate.rate
              with frame rt-2 down.
         
         clear frame rt-2 all no-pause.
         
         for each t-room-type 
               where (if by-room then t-room-type.type = room-type else true),
            each t-floor,
            each rate
               where rate.floor = t-floor.floor and
                     rate.type-of-room = t-room-type.type and
                     (if start-date = ? then true else rate.start-date <= start-date) and
                     (if end-date = ? then true else rate.end-date >= end-date)
               no-lock
            break by t-room-type.type
                  by t-floor.floor:

               if first-of(t-floor.floor) then c-rate = ?.
               
               if c-rate = ? and rate.end-date >= today then c-rate = rate.rate.

               display t-room-type.name when first-of(t-room-type.type)
                       t-floor.floor when first-of(t-floor.floor)
                       rate.start-date 
                       rate.end-date
                       rate.rate
                       with frame rt-2.
               down with frame rt-2.

               if last-of(t-floor.floor) then do:
                  display "Current Rate" @ t-room-type.name 
                          c-rate @ rate.rate 
                          with frame rt-2.
                  down with frame rt-2.
               end.
         end.
      end.

      pause message "Press any key to return".
   end.
   else do:
      def var f-name as char.
      f-name = "".
      repeat while f-name = "":
         message "Enter file name" update f-name format "x(20)".
      end.
      
      def stream rpt.
      output stream rpt to value(f-name) paged page-size 20.
      
      form header
         u-name 
         space(40)
         "H O T E L"
         space(40)
         today format "99/99/9999" at 114
         string(time, "hh:mm:ss") skip
         skip
         screen-title at 40 format "x(40)"
         page-number(rpt) format "Page: >>>>>9"     to 132
         skip(2)
         with frame gf-header width 132 no-attr-space no-underline no-box page-top.
      form header
         "Floor" at 1
         "Type of Room" at 10
         "Start Date" at 40
         "End Date" at 60
         "Rate" at 80 
         skip 
         fill("-", 9) at 1 format "x(8)"
         fill("-", 29) at 10 format "x(28)"
         fill("-", 19) at 40 format "x(18)"
         fill("-", 19) at 60 format "x(18)"
         fill("-", 19) at 80 format "x(18)"
         with frame hf-1 width 132 no-attr-space no-underline no-box page-top. 

      form header
         "Type of Room" at 1
         "Floor" at 30
         "Start Date" at 40
         "End Date" at 60
         "Rate" at 80 
         skip 
         fill("-", 29) at  1 format "x(28)"
         fill("-", 9)  at 30 format "x(8)"
         fill("-", 19) at 40 format "x(18)"
         fill("-", 19) at 60 format "x(18)"
         fill("-", 19) at 80 format "x(18)"
         with frame hf-2 width 132 no-attr-space no-underline no-box page-top. 

      view stream rpt frame gf-header.
      
      if by-floor then do:
         view stream rpt frame hf-1.
      end.
      else do:
         view stream rpt frame hf-2.
      end.

      if by-floor then do:

         form t-floor.floor at 1
              t-room-type.name at 10
              rate.start-date  at 40
              rate.end-date at 60
              rate.rate at 80
              with frame rf-1 width 132 no-attr-space no-underline down no-labels no-box.

         clear frame rf-1 all no-pause.
         
         for each t-floor, 
            each t-room-type 
               where (if by-room then t-room-type.type = room-type else true),
            each rate
               where rate.floor = t-floor.floor and
                     rate.type-of-room = t-room-type.type and
                     (if start-date = ? then true else rate.start-date <= start-date) and
                     (if end-date = ? then true else rate.end-date >= end-date)
               no-lock
            break by t-floor.floor
                  by t-room-type.type:

               if first-of(t-room-type.type) then c-rate = ?.
               
               if c-rate = ? and rate.end-date >= today then c-rate = rate.rate.

               display stream rpt t-floor.floor when first-of(t-floor.floor)
                       t-room-type.name when first-of(t-room-type.type)
                       rate.start-date 
                       rate.end-date
                       rate.rate
                       with frame rf-1.
               down stream rpt with frame rf-1.

               if last-of(t-room-type.type) then do:
                  display stream rpt "Current Rate" @ t-room-type.name 
                          c-rate @ rate.rate 
                          with frame rf-1.
                  down stream rpt 1 with frame rf-1.
               end.
         end.

      end.
      else do:
         form t-room-type.name at 1
              t-floor.floor at 30
              rate.start-date at 40
              rate.end-date at 60
              rate.rate at 80
              with frame rf-2 width 132 no-attr-space no-underline down no-labels no-box.
         
         clear frame rf-2 all no-pause.
         
         for each t-room-type 
               where (if by-room then t-room-type.type = room-type else true),
            each t-floor,
            each rate
               where rate.floor = t-floor.floor and
                     rate.type-of-room = t-room-type.type and
                     (if start-date = ? then true else rate.start-date <= start-date) and
                     (if end-date = ? then true else rate.end-date >= end-date)
               no-lock
            break by t-room-type.type
                  by t-floor.floor:
               if first-of(t-floor.floor) then c-rate = ?.
               
               if c-rate = ? and rate.end-date >= today then c-rate = rate.rate.

               display stream rpt t-room-type.name when first-of(t-room-type.type)
                       t-floor.floor when first-of(t-floor.floor)
                       rate.start-date 
                       rate.end-date
                       rate.rate
                       with frame rf-2.
               down stream rpt with frame rf-2.

               if last-of(t-floor.floor) then do:
                  display stream rpt "Current Rate" @ t-room-type.name 
                          c-rate @ rate.rate 
                          with frame rf-2.
                  down stream rpt 1 with frame rf-2.
               end.
         end.
      end.
      
      message "Report completed - " + string(page-number(rpt)) + " pages".
      pause.
      output stream rpt close.
   end.
   
   hide all no-pause.
end.

publish "pop-program".