package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.checkout</code> (previously
 * <code>hotel.checkout</code>).
 */
public interface Checkout
extends DataModelObject
{
   /**
    * Getter: Reservation Number
    * 
    * @return  Reservation Number
    */
   public integer getReservationId();

   /**
    * Setter: Reservation Number
    * 
    * @param   reservationId
    *          Reservation Number
    */
   public void setReservationId(NumberType reservationId);

   /**
    * Getter: Room Charges
    * 
    * @return  Room Charges
    */
   public decimal getRoomCharges();

   /**
    * Setter: Room Charges
    * 
    * @param   roomCharges
    *          Room Charges
    */
   public void setRoomCharges(NumberType roomCharges);

   /**
    * Getter: Sales Tax
    * 
    * @return  Sales Tax
    */
   public decimal getSalesTax();

   /**
    * Setter: Sales Tax
    * 
    * @param   salesTax
    *          Sales Tax
    */
   public void setSalesTax(NumberType salesTax);

   /**
    * Getter: Total
    * 
    * @return  Total
    */
   public decimal getTotal();

   /**
    * Setter: Total
    * 
    * @param   total
    *          Total
    */
   public void setTotal(NumberType total);

   /**
    * Getter: State
    * 
    * @return  State
    */
   public character getState();

   /**
    * Setter: State
    * 
    * @param   state
    *          State
    */
   public void setState(Text state);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Checkout, Buffer
   {
   }
}
