package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.checkout_rooms</code> (previously
 * <code>hotel.checkout-rooms</code>).
 */
public interface CheckoutRooms
extends DataModelObject
{
   /**
    * Getter: ID
    * 
    * @return  ID
    */
   public integer getReservationId();

   /**
    * Setter: ID
    * 
    * @param   reservationId
    *          ID
    */
   public void setReservationId(NumberType reservationId);

   /**
    * Indexed Getter: Guests
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 4</code>).
    * 
    * @return  Guests
    */
   public integer getGuestIds(int index);

   /**
    * Indexed Setter: Guests
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 4</code>).
    * @param   element
    *          Guests
    */
   public void setGuestIds(int index, NumberType element);

   /**
    * Getter: Minibar Charges
    * 
    * @return  Minibar Charges
    */
   public decimal getMinibarCharges();

   /**
    * Setter: Minibar Charges
    * 
    * @param   minibarCharges
    *          Minibar Charges
    */
   public void setMinibarCharges(NumberType minibarCharges);

   /**
    * Getter: Laundry Charges
    * 
    * @return  Laundry Charges
    */
   public decimal getLaundryCharges();

   /**
    * Setter: Laundry Charges
    * 
    * @param   laundryCharges
    *          Laundry Charges
    */
   public void setLaundryCharges(NumberType laundryCharges);

   /**
    * Getter: Room Charges
    * 
    * @return  Room Charges
    */
   public decimal getRoomCharges();

   /**
    * Setter: Room Charges
    * 
    * @param   roomCharges
    *          Room Charges
    */
   public void setRoomCharges(NumberType roomCharges);

   /**
    * Getter: Room Number
    * 
    * @return  Room Number
    */
   public integer getRoomNumber();

   /**
    * Setter: Room Number
    * 
    * @param   roomNumber
    *          Room Number
    */
   public void setRoomNumber(NumberType roomNumber);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends CheckoutRooms, Buffer
   {
      /**
       * Getter: Guests
       * 
       * @return  Guests
       */
      public integer[] getGuestIds();

      /**
       * Indexed Getter: Guests
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 4</code>).
       * 
       * @return  Guests
       */
      public integer getGuestIds(NumberType index);

      /**
       * Indexed Setter: Guests
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 4</code>).
       * @param   element
       *          Guests
       */
      public void setGuestIds(NumberType index, NumberType element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: Guests
       * 
       * @param   element
       *          Scalar value to which to set all elements of: Guests
       */
      public void setGuestIds(NumberType element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: Guests
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: Guests
       */
      public void setGuestIds(NumberType[] elements);

   }
}
