package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.guest</code> (previously
 * <code>hotel.guest</code>).
 */
public interface Guest
extends DataModelObject
{
   /**
    * Getter: Guest ID
    * 
    * @return  Guest ID
    */
   public integer getGuestId();

   /**
    * Setter: Guest ID
    * 
    * @param   guestId
    *          Guest ID
    */
   public void setGuestId(NumberType guestId);

   /**
    * Getter: First Name
    * 
    * @return  First Name
    */
   public character getFirstName();

   /**
    * Setter: First Name
    * 
    * @param   firstName
    *          First Name
    */
   public void setFirstName(Text firstName);

   /**
    * Getter: Last Name
    * 
    * @return  Last Name
    */
   public character getLastName();

   /**
    * Setter: Last Name
    * 
    * @param   lastName
    *          Last Name
    */
   public void setLastName(Text lastName);

   /**
    * Getter: ID Type
    * 
    * @return  ID Type
    */
   public integer getIdType();

   /**
    * Setter: ID Type
    * 
    * @param   idType
    *          ID Type
    */
   public void setIdType(NumberType idType);

   /**
    * Getter: ID Number
    * 
    * @return  ID Number
    */
   public character getIdNumber();

   /**
    * Setter: ID Number
    * 
    * @param   idNumber
    *          ID Number
    */
   public void setIdNumber(Text idNumber);

   /**
    * Getter: Date of Birth
    * 
    * @return  Date of Birth
    */
   public date getDateOfBirth();

   /**
    * Setter: Date of Birth
    * 
    * @param   dateOfBirth
    *          Date of Birth
    */
   public void setDateOfBirth(date dateOfBirth);

   /**
    * Getter: Phone #
    * 
    * @return  Phone #
    */
   public character getPhoneNumber();

   /**
    * Setter: Phone #
    * 
    * @param   phoneNumber
    *          Phone #
    */
   public void setPhoneNumber(Text phoneNumber);

   /**
    * Getter: Country
    * 
    * @return  Country
    */
   public character getCountry();

   /**
    * Setter: Country
    * 
    * @param   country
    *          Country
    */
   public void setCountry(Text country);

   /**
    * Getter: City
    * 
    * @return  City
    */
   public character getCity();

   /**
    * Setter: City
    * 
    * @param   city
    *          City
    */
   public void setCity(Text city);

   /**
    * Getter: Street 2
    * 
    * @return  Street 2
    */
   public character getStreet2();

   /**
    * Setter: Street 2
    * 
    * @param   street2
    *          Street 2
    */
   public void setStreet2(Text street2);

   /**
    * Getter: Street 1
    * 
    * @return  Street 1
    */
   public character getStreet1();

   /**
    * Setter: Street 1
    * 
    * @param   street1
    *          Street 1
    */
   public void setStreet1(Text street1);

   /**
    * Getter: State/Province
    * 
    * @return  State/Province
    */
   public character getState();

   /**
    * Setter: State/Province
    * 
    * @param   state
    *          State/Province
    */
   public void setState(Text state);

   /**
    * Getter: Postal Code
    * 
    * @return  Postal Code
    */
   public character getZip();

   /**
    * Setter: Postal Code
    * 
    * @param   zip
    *          Postal Code
    */
   public void setZip(Text zip);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Guest, Buffer
   {
   }
}
