package com.goldencode.hotel.ui;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

public interface RatesReportF1
extends CommonFrame
{
   public static final Class configClass = RatesReportF1Def.class;

   public date getStartDate();

   public void setStartDate(date parm);

   public void setStartDate(BaseDataType parm);

   public FillInWidget widgetStartDate();

   public date getEndDate();

   public void setEndDate(date parm);

   public void setEndDate(BaseDataType parm);

   public FillInWidget widgetEndDate();

   public logical isByFloor();

   public void setByFloor(logical parm);

   public void setByFloor(boolean parm);

   public void setByFloor(BaseDataType parm);

   public FillInWidget widgetByFloor();

   public logical isByRoom();

   public void setByRoom(logical parm);

   public void setByRoom(boolean parm);

   public void setByRoom(BaseDataType parm);

   public ToggleBoxWidget widgetByRoom();

   public integer getRoomType();

   public void setRoomType(integer parm);

   public void setRoomType(int parm);

   public void setRoomType(BaseDataType parm);

   public ComboBoxWidget widgetRoomType();

   public static class RatesReportF1Def
   extends WidgetList
   {
      FillInWidget startDate = new FillInWidget();

      FillInWidget endDate = new FillInWidget();

      FillInWidget byFloor = new FillInWidget();

      ToggleBoxWidget byRoom = new ToggleBoxWidget();

      ComboBoxWidget roomType = new ComboBoxWidget();

      public void setup(CommonFrame frame)
      {
         frame.setDown(1);
         frame.setCentered(true);
         frame.setSideLabels(true);
         startDate.setDataType("date");
         startDate.setForceLabel(true);
         startDate.setLabel("Start Date");
         startDate.setRow(1);
         startDate.setColumn(20);
         startDate.setAlign(ControlEntity.ALIGN_COLON);
         startDate.setHelpStatic("Leave blank for all before");
         endDate.setDataType("date");
         endDate.setForceLabel(true);
         endDate.setLabel("End Date");
         endDate.setRow(2);
         endDate.setColumn(20);
         endDate.setAlign(ControlEntity.ALIGN_COLON);
         endDate.setHelpStatic("Leave blank for all after");
         byFloor.setDataType("logical");
         byFloor.setForceLabel(true);
         byFloor.setLabel("Group by");
         byFloor.setRow(3);
         byFloor.setColumn(20);
         byFloor.setAlign(ControlEntity.ALIGN_COLON);
         byFloor.setHelpStatic("Group by (F)loor or (R)oom-type");
         byRoom.setDataType("logical");
         byRoom.setForceLabel(true);
         byRoom.setLabel("Set room type?");
         byRoom.setRow(4);
         byRoom.setColumn(20);
         byRoom.setAlign(ControlEntity.ALIGN_COLON);
         roomType.setDataType("integer");
         roomType.setInitialInnerLines(5);
         roomType.setForceLabel(true);
         roomType.setLabel("Room type");
         roomType.setRow(5);
         roomType.setColumn(20);
         roomType.setAlign(ControlEntity.ALIGN_COLON);
         endDate.setFormat("99/99/99");
         endDate.setColumnLabel("To Date");
         startDate.setFormat("99/99/99");
         startDate.setColumnLabel("From Date");
         roomType.setFormat(">>>,>>>,>>>");
         roomType.setColumnLabel("Type of Room");
         byFloor.setFormat("Floor/Room Type");
      }

      {
         addWidget("startDate", "start-date", startDate);
         addWidget("endDate", "end-date", endDate);
         addWidget("byFloor", "by-floor", byFloor);
         addWidget("byRoom", "by-room", byRoom);
         addWidget("roomType", "room-type", roomType);
      }
   }
}
